/*
 ****************** File CtrlDac214x125m.h *************************
 *
 *  Definitions of user application interface
 *	structures and constants
 *	for BRD_ctrl : DAC214x125M section
 *
 * (C) InSys by Sklyarov A., Dorokhin A. March 2008
 *
 *
 ************************************************************
*/

#ifndef _CTRL_DAC214X125M_H
 #define _CTRL_DAC214X125M_H

#include "CtrlDac.h"

#pragma pack(push, 1)    

// Numbers of Specific Command
typedef enum _DAC214X125M_NUM_CMD
{
	DAC214X125Mcmd_SETDACMODE		= 64, // Set DAC Mode (PBRD_SetDacMode)
	DAC214X125Mcmd_ENABLECODOGRAM	= 65, // Enable Codegram(PBRD_EnableCodogram)
	DAC214X125Mcmd_DISABLECODOGRAM	= 66, // Disable Codegram(NULL)
	DAC214X125Mcmd_SETMODERI		= 67, //  On(1)/Off(0) mixer(U32)
	DAC214X125Mcmd_SETSLEEP			= 68, //  On(1)/Off(0) SleepMode(U32)
	DAC214X125Mcmd_SETMIXERWPOINT	= 69, // (0-127) (PBRD_SetMixerWPoint)
	DAC214X125Mcmd_SETCYCLEMODE		= 70, // (U32)
} DAC214X125M_NUM_CMD;

typedef struct _BRD_SetDacMode
{
	 U32	pf;
	 U32	zstuff;
	 U32	divpll;
} BRD_SetDacMode, *PBRD_SetDacMode;

typedef struct  _BRD_EnableCodogram
{
	U32 iscycle,  //   : 1-, 0- 
		lcycle,   //   CG_CNT
		ncycles,  //   CG_CYCLE
		sstr0,    //   STB0_SET
		estr0,    //   STB0_CLR
		sstr1,    //   STB1_SET
		estr1,    //   STB1_CLR
		sstr2,    //   STB2_SET
		estr2,    //   STB2_CLR
		sstrdac,  //   STB_DAC_SET
		estrdac,  //   STB_DAC_CLR
		sstrobri, //   STB_RI_SET
		estrobri, //   STB_RI_CLR
		sstradc,  //   STB_ADC_SET
		estradc;  //   STB_ADC_CLR
} BRD_EnableCodogram, *PBRD_EnableCodogram;

typedef struct _BRD_SetMixerWPoint
{
	U32		chan;			// channel 0,1
	U32		mixwpoint;		// 0-255
} BRD_SetMixerWPoint, *PBRD_SetMixerWPoint;

#pragma pack(pop)    

#endif // _CTRL_DAC214X125M_H

//
// End of file
//