//********************************************************
//
// Example Application of BRD_xxx functions for DAC214X125M service.
//
// (C) InSys by Sklyarov A. Apr 2008
//
//=********************************************************

#include	<conio.h>
#include	<stdio.h>
#include	<tchar.h>
#include	<ctype.h>
#include	<windows.h>
#include	<conio.h>
#include	<dos.h>
#include	<math.h>
#include	"brd.h"
#include	"ctrlstrm.h"
#include	"ctrlcmpsc.h"
#include	"CtrlDac.h"
#include	"CtrlDac214x125m.h"

#define PI2   6.2831853071795864
const U16 PLD_CFG_TAG	= 0x0500; // tag of PLD
BRD_Handle g_hCaptSrv[10];
S32 g_nCaptSrv = 0;
S32	SamplesOnPeriod=10;
//__int64 g_OutBufSize;
U32 g_OutBufSize;
S32 g_DacFifoSize;
S32	status;

//------------------------------------------------------------------------
void DisplayError(S32 status, TCHAR* cmd_str);
S32	CaptureSrv(BRD_Handle handle,TCHAR* serviceName );
S32	SetParamSrv(void);
S32	WorkSrv(void);
S32	FifoOutputCPU( PVOID pSig, ULONG bBufSize);
S32	FifoOutputDMA(void);
S32	FifoOutputCycleDMA(void);
S32 FifoOutputCPUCycleFIFO( PVOID pSig, U32 bBufSize, U32 cycle);
void CorrectOutFreq(void);
S32 CalcSignal(S32 *samples, S32 nsamples);
bool  ReadIniFile( TCHAR *pFileName );
//------------------------------------------------------------------------

//---------------------------------------------------------------------------
typedef struct 
{
	U32  WorkMode;
	U32  CycleOneTime;
	U32  SamplesPerChannel;
	U32  IsSystemMemory;
	U32  IsAlwaysLoadPld;
	U32	 MasterSlave;
	U32  ClockValue;
    U32  OutFreq;
    U32  AmpChan0;
    U32  AmpChan1;
    U32  TypeOfSignal;
	U32	 Zeroing;
	U32	 StartSource;
	U32	 StartInverse;
	U32  StartTrigger; 
	U32	 StopSource;
	U32	 StopInverse;
	float ThresholdComp1;
	TCHAR PldFileName[100];
	TCHAR ServiceName[100];
	TCHAR IniFileName[100];
}EXAM_PARAM;

EXAM_PARAM g_ExamParam=
{
	1,		// WorkMode
	1,		// CycleOneTime
	1024,	// SamplesPerChannel
	0,		// IsSystemMemory
	1,		// IsAlwaysLoadPLD;
	1,		// MasterSlave;
	100000000,//  ClockValue -   () 
    50000,	  //  OutFreq-    ()
    32000,	  //  AmpChan0 -     0    
    32000,	  //  AmpChan1 -     1    
    1,		//  TypeOfSignal -    0-sin/sin, 1-sin/cos
	1,		//	Zeroing;
	0,		// StartSource: source of start : 0-programm, 2-SDX(comparator 1)
	0,		// StartInverse: inverse signal start: 0-no, 1-yes    
	0,		// StartTrigger: start mode : 0- potential, 1-trigger
	0,		// StopSource: source of stop by trigger start mode
	0,		// StopInverse: inverse signal stop: 0-no, 1-yes
	0.1,	// ThresholdComp1 (v)
	{""},						// PldFileName
	{"DAC214X125M0"},			// ServiceName
	{"\\exam_dac214x125m.ini"}  //IniFileName
};
//---------------------------------------------------------------------------
typedef struct 
{
    U32  Pf;
	U32	 Zstuff;
	U32	 Divpll;
	U32	 Codegram;
	U32	 ModeRi;
    U32  Gain0;
    U32  Gain1;
    U32  Wpoint0;
    U32  Wpoint1;
} DAC_PARAM;				// ADMDAC214x125M 

DAC_PARAM   g_DacParam =	
{
    0,			//  Pf: 0 - LPF, 1 - HPF
	0,			//  Zstuff:0-no zero stuff, 1-yes zero stuff
	1,			//	Divpll: 0,1,2,3
	1,			//  Codegram: 0 -  , 1- 
	0,			//  ModeRi: 0 -  , 1 -  
	0,			//  Gain0 -   0(0 - 127)
    0,			//  Gain1 -   0(0 - 127)
    190,		//  Wpoint0 (0 -255)
    190			//  Wpoint1 (0 - 255)

};

//---------------------------------------------------------------------------
BRD_EnableCodogram  g_EnableCodogram={
		0,			// iscycle-  : 1-, 0- 
		100,		// lcycle -   (  CG_CNT)
		 2,			// ncycles -   (  CG_CYCLE)
		4,			// sstr0 -   STB0 (  STB0_SET)
		10,			// estr0 -   STB0 (  STB0_CLR)
		6,			// sstr1 -   STB1 (  STB1_SET)
		12,			// estr1 -   STB1 (  STB1_CLR)
		10,			// sstr2 -   STB2 (  STB2_SET)
		14,			// estr2 -   STB2 (  STB2_CLR)
		16,			// sstrdac -   STB_DAC (  STB_DAC_SET)
		20,			// estrdac -   STB_DAC (  STB_DAC_CLR)
		16,			// sstrobri -   STB_RI (  STB_RI_SET)
		20,			// estrobri -   STB_RI (  STB_RI_CLR0)
		20,			// sstradc -   STB_ADC (  STB_ADC_SET)
		16,			// estradc -   STB_ADC (  STB_ADC_CLR)
};

//=**************************** ReadIniPrepare ******************************
//=***************************************************************************
typedef struct {char section[25]; int format;void *ptr; char title[25]; } TReadIniEntry;
static TReadIniEntry    iniEntry[] =
{
	{"Option", 0, (void*)&g_ExamParam.WorkMode, "WorkMode" },
	{"Option", 0, (void*)&g_ExamParam.CycleOneTime, "CycleOneTime" },
	{"Option", 0, (void*)&g_ExamParam.SamplesPerChannel, "SamplesPerChannel" },
	{"Option", 0, (void*)&g_ExamParam.IsSystemMemory, "IsSystemMemory" },
	{"Option", 3, (void*)&g_ExamParam.PldFileName, "PldFileName" },
	{"Option", 0, (void*)&g_ExamParam.IsAlwaysLoadPld, "IsAlwaysLoadPld" },
	{"Option", 0, (void*)&g_ExamParam.MasterSlave, "MasterSlave" },
    {"Option", 0, (void*)&g_ExamParam.StartSource,"StartSource" },
    {"Option", 0, (void*)&g_ExamParam.StartInverse,"StartInverse" },
    {"Option", 0, (void*)&g_ExamParam.StartTrigger,"StartTrigger" },
    {"Option", 0, (void*)&g_ExamParam.StopSource,"StopSource" },
    {"Option", 0, (void*)&g_ExamParam.StopInverse,"StopInverse" },
    {"Option", 1, (void*)&g_ExamParam.ThresholdComp1,"ThresholdComp1" },
    {"Option", 0, (void*)&g_ExamParam.ClockValue,"Clock" },
    {"Option", 0, (void*)&g_ExamParam.OutFreq,"OutFreq" },
    {"Option", 0, (void*)&g_ExamParam.AmpChan0,"AmpChan0" },
    {"Option", 0, (void*)&g_ExamParam.AmpChan1,"AmpChan0" },
    {"Option", 0, (void*)&g_ExamParam.TypeOfSignal,"TypeOfSignal" },
    {"Option", 0, (void*)&g_ExamParam.Zeroing,"Zeroing" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Pf,"PF" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Zstuff,"ZSTUF" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Divpll,"DIVPLL" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Codegram,"CODEGRAM" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Gain0,"GAIN0" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Gain1,"GAIN1" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Wpoint0,"WPOINT0" },
    {"device0_dac214x125m0", 0, (void*)&g_DacParam.Wpoint1,"WPOINT1" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.iscycle,"CODEGC" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.lcycle,"LCYCLE" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.ncycles,"NCYCLES" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.sstr0,"SSTB0" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.estr0,"ESTB0" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.sstr1,"SSTB1" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.estr1,"ESTB1" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.sstr2,"SSTB2" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.estr2,"ESTB2" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.sstrdac,"SSTBDAC" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.estrdac,"ESTBDAC" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.sstrobri,"SSTBRI" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.estrobri,"ESTBRI" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.sstradc,"SSTBADC" },
    {"device0_dac214x125m0", 0, (void*)&g_EnableCodogram.estradc,"ESTBADC" },
};
//---------------------------------------------------------------------------

//=****************************** main **************************************
//=**************************************************************************
void main( int argc, char *argv[] )
{
	S32		status;
	if(!ReadIniFile(g_ExamParam.IniFileName ))
	{
		printf("Can't open file: %s !\n",g_ExamParam.IniFileName);
		printf("Press any key for leaving program...\n");
		_getch();
		_exit(0);
	}
	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	
	S32	DevNum;
	status = BRD_init("brd.ini", &DevNum); //  

	//   LID (   )
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	BRD_Info	info;
	info.size = sizeof(info);
	BRD_Handle handle[10];

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &info); //    
		printf("Board %d:  %s pid = %d\n",iDev,info.name,info.pid);
		printf("   DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev= %d, Slot= %d.\n", 
			    info.boardType >> 16, info.boardType & 0xff, info.bus, info.dev, info.slot);
		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_EXCLUSIVE, NULL); //     
	//	handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_SHARED, NULL); //     
		if(handle[iDev] <=0)printf("   Open Error!\n");
		if(handle[iDev] > 0)
		{
			BRD_PuList PuList[5];
			U32 ItemReal;
			status = BRD_puList(handle[iDev], PuList, 5, &ItemReal); //    
			if(ItemReal > 5)
			{
				ItemReal=5; 
				printf("   Number of programable unit >5 !\n");
			}
			for(U32 j = 0; j < ItemReal; j++)
			{
				printf("   Prog unit %d: %s, Id = %d, Code = %x, Attr = %x.\n",
									j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
				
				if(PuList[j].puCode == PLD_CFG_TAG)
				{ //   
						U32	PldState;
						status = BRD_puState(handle[iDev], PuList[j].puId, &PldState);
						printf("   PLD State = %d\n", PldState);
						if(PldState==0 || g_ExamParam.IsAlwaysLoadPld==1)
						{ //  
					 		printf("   Loading PLD -> %s ...",g_ExamParam.PldFileName);
							status = BRD_puLoad(handle[iDev], PuList[j].puId, g_ExamParam.PldFileName, &PldState);
							if(BRD_errcmp(status, BRDerr_OK))
							{	
								printf(" OK!\n");
								PldState=1;
							}
							else 
							{	
								printf("  Error! \n");
								PldState=0;
							}
					    }
						if(PldState)CaptureSrv(handle[iDev],g_ExamParam.ServiceName);		
		         }
             }
         }
	}
	if(g_nCaptSrv>0)
	{
		SetParamSrv();
		WorkSrv();
	}else
	{
		printf("\n   No Service!\n");
	}
	for(int i = 0; i < g_nCaptSrv; i++)
		status = BRD_release(g_hCaptSrv[i], 0);

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
		status = BRD_close(handle[iDev]); //   
	printf("BRD_close: OK\n");
	status = BRD_cleanup();
	printf("BRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();
}
// End of main
//=******************* DisplayError ***********************
//=********************************************************

void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break; 
	case	BRDerr_NOT_ACTION:
		sprintf_s(msg, "%s:  BRDerr_NOT_ACTION\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error\n", cmd_str);
		break;
	}
	printf(msg);
}
//=******************* Capture Srv ************************
//=********************************************************
S32 CaptureSrv(BRD_Handle handle,TCHAR* serviceName )
{
	S32		status;
	U32 mode = BRDcapt_EXCLUSIVE;
	U32	ItemReal;
	BRD_ServList srvList[10];
	status = BRD_serviceList(handle, 0, srvList, 10, &ItemReal);
	for(U32 j = 0; j < ItemReal; j++)
	{
		printf("   Srv %d:  %s, Attr = %X.\n",j, srvList[j].name, srvList[j].attr);
	}
    for(int iSrv = 0; iSrv < ItemReal; iSrv++)
    {			
		if(!strcmp(srvList[iSrv].name,g_ExamParam.ServiceName))
		{
		   printf("   Capture %s mode: EXCLUSIVE...",g_ExamParam.ServiceName); 
		   BRD_Handle hSrv = BRD_capture(handle, 0, &mode,srvList[iSrv].name, 10000);
			if(hSrv > 0)
			{
				g_hCaptSrv[g_nCaptSrv++]=hSrv;
				printf("OK!\n");

			}else
			{
				printf("Error!\n");
			}
		}
    }	
	return status;
}
//=**************************************************************************
//					    
//=**************************************************************************
S32 SetParamSrv(void)
{
	S32		status;
	U32	master=1; //Single};

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETMASTER, &master);
	if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_DAC_SETMASTER:  master = %d\n", master); 
	else
			DisplayError(status, "BRDctrl_DAC_SETMASTER");

	BRD_ClkMode clkMode;
	clkMode.src=0;
	clkMode.value=g_ExamParam.ClockValue;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETCLKMODE, &clkMode);
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("BRDctrl_DAC_SETCLKMODE: valueClk = %.0f Hz\n",clkMode.value);
	}
	else
				DisplayError(status, "BRDctrl_DAC_SETCLKMODE");

	BRD_ValChan gainChan; 
	gainChan.chan=0;
	gainChan.value=(REAL64)g_DacParam.Gain0;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETGAIN, &gainChan);
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("BRDctrl_DAC_SETGAIN: Gain0 = %d\n",g_DacParam.Gain0);
	}
	else
				DisplayError(status, "BRDctrl_DAC_SETGAIN");

	gainChan.chan=1;
	gainChan.value=(REAL64)g_DacParam.Gain1;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETGAIN, &gainChan);
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("BRDctrl_DAC_SETGAIN: Gain1 = %d\n",g_DacParam.Gain1);
	}
	else
				DisplayError(status, "BRDctrl_DAC_SETGAIN");

	BRD_SetDacMode setDacMode;
	setDacMode.pf=g_DacParam.Pf;
	setDacMode.zstuff=g_DacParam.Zstuff;
	setDacMode.divpll=g_DacParam.Divpll;

	BRD_DacSpec dacSpec;
	dacSpec.command=DAC214X125Mcmd_SETDACMODE;
	dacSpec.arg= (PVOID)&setDacMode; 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("DAC214X125Mcmd_SETDACMODE: pf= %d, zstuff= %d, divpll = %d\n",setDacMode.pf,setDacMode.zstuff,setDacMode.divpll);
	}
	else
				DisplayError(status, "DAC214X125Mcmd_SETDACMODE");


	BRD_SetMixerWPoint   setMixerWPoint;
	setMixerWPoint.chan=0;
	setMixerWPoint.mixwpoint=g_DacParam.Wpoint0;
	dacSpec.command=DAC214X125Mcmd_SETMIXERWPOINT;
	dacSpec.arg= (PVOID)&setMixerWPoint; 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("DAC214X125Mcmd_SETMIXERWPOINT: MixerWPoint0 = %d \n",setMixerWPoint.mixwpoint);
	}
	else
				DisplayError(status, "DAC214X125Mcmd_SETMIXERWPOINT");

	setMixerWPoint.chan=1;
	setMixerWPoint.mixwpoint=g_DacParam.Wpoint1;
	dacSpec.command=DAC214X125Mcmd_SETMIXERWPOINT;
	dacSpec.arg= (PVOID)&setMixerWPoint; 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("DAC214X125Mcmd_SETMIXERWPOINT: MixerWPoint1 = %d \n",setMixerWPoint.mixwpoint);
	}
	else
				DisplayError(status, "DAC214X125Mcmd_SETMIXERWPOINT");

	   // Set Codoram Parameters
    if( g_DacParam.Codegram==0 )
    {
		dacSpec.command=DAC214X125Mcmd_DISABLECODOGRAM;
		dacSpec.arg= NULL; 
	 	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
		if(BRD_errcmp(status, BRDerr_OK))
		{
			printf("DAC214X125Mcmd_DISABLECODOGRAM \n");
		}
		else
			DisplayError(status, "DAC214X125Mcmd_DISABLECODOGRAM");
		dacSpec.command=DAC214X125Mcmd_SETMODERI;
		dacSpec.arg= (PVOID)&g_DacParam.ModeRi; 

		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
		if(BRD_errcmp(status, BRDerr_OK))
		{
			printf("DAC214X125Mcmd_SETMODERI: ModeRi= %d \n",g_DacParam.ModeRi);
		}
		else
				DisplayError(status, "DAC214X125Mcmd_SETMODERI");
	}
    else //g_DacParam.Codegram==1
    { 
 		dacSpec.command=DAC214X125Mcmd_ENABLECODOGRAM;
		dacSpec.arg= (PVOID)&g_EnableCodogram; 
 	 	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
		if(BRD_errcmp(status, BRDerr_OK))
		{
			printf("DAC214X125Mcmd_ENABLECODOGRAM \n");
		}
		else
			DisplayError(status, "DAC214X125Mcmd_ENABLECODOGRAM");

    }
	U32	sleep=0;
	dacSpec.command=DAC214X125Mcmd_SETSLEEP;
	dacSpec.arg= (PVOID)&sleep; 
 	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("DAC214X125Mcmd_SETSLEEP: Sleep = %d\n",sleep);
	}
	else
		DisplayError(status, "DAC214X125Mcmd_SETSLEEP");
	BRD_StartMode  startMode;
	startMode.startSrc= g_ExamParam.StartSource;
	startMode.startInv= g_ExamParam.StartInverse;
	startMode.trigOn= g_ExamParam.StartTrigger;
	startMode.trigStopSrc= g_ExamParam.StopSource;
 	startMode.stopInv= g_ExamParam.StopInverse;
	startMode.reStartMode=0;

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSTARTMODE, &startMode);
	if(BRD_errcmp(status, BRDerr_OK))
	printf("BRDctrl_DAC_SETSTARTMODE:  src = %d inv = %d  trig = %d  thresh = %.1fV restart = %d\n",
	startMode.startSrc,startMode.startInv,startMode.trigOn,g_ExamParam.ThresholdComp1,startMode.reStartMode);
	else
		DisplayError(status, "BRDctrl_DAC_SETSTARTMODE");
	BRD_CmpSC cmp_sc;
	cmp_sc.src= 0;
	cmp_sc.thr[0]=g_ExamParam.ThresholdComp1;
	cmp_sc.thr[1]=g_ExamParam.ThresholdComp1;

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_CMPSC_SET, &cmp_sc);


	return 1;
}
//*********************************************************************************************
S32 WorkSrv(void)
{
	S32	status;
	S32	nblock=0;
	U32 tetrad;
	ULONG source;
	ULONG Enable;

	g_OutBufSize=g_ExamParam.SamplesPerChannel*4;	
	BRD_DacCfg dac_cfg;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_GETCFG, &dac_cfg);
	g_DacFifoSize = dac_cfg.FifoSize; //   FIFO  
	printf("\nDacFifoSize = %d bytes\n",g_DacFifoSize);
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==0)	// One time DMA 
	{
		printf("WorkMode: -- One time  DMA  -- \n");
		printf("\n");
		int tmp=g_ExamParam.SamplesPerChannel/1024;
		if(tmp==0)tmp=1;
		g_ExamParam.SamplesPerChannel=tmp*1024;
		g_OutBufSize=g_ExamParam.SamplesPerChannel*4;	
		printf("SamplesPerChannel = %d  ",g_ExamParam.SamplesPerChannel);
		printf("OutFreq = %d Hz\n",g_ExamParam.OutFreq);
		BRDctrl_StreamCBufAlloc buf_dscr;
		buf_dscr.dir = BRDstrm_DIR_OUT;
		buf_dscr.isCont = g_ExamParam.IsSystemMemory; 
		buf_dscr.blkNum = 1;
		buf_dscr.blkSize = (U32)g_OutBufSize;
		buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];
		status = BRD_ctrl(g_hCaptSrv[0],0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr);

		source = 0;		//      FIFO 
		//	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSOURCE, &source);
		//	BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_GETSRCSTREAM, &tetrad);
	    //	BRD_ctrl(g_hCaptSrv[0], 0,  BRDctrl_STREAM_SETSRC, &tetrad);
		CalcSignal((S32*)buf_dscr.ppBlk[0], g_ExamParam.SamplesPerChannel);
		if(g_ExamParam.CycleOneTime==0)	//  
		{
			FifoOutputDMA();
		}
		if(g_ExamParam.CycleOneTime==1)	// c em
		{
			printf("Press any key for stop!\n");
			while(!_kbhit())
			{
				if(FifoOutputDMA()==0)break;
				nblock++;
    			printf("\rBlock %d",nblock);
			}
			_getch();
		}
		printf("\n");
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
		delete[] buf_dscr.ppBlk;
		return 1;
	}
	//-------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==1)	//  FIFO ( One time FIFO) 
	{
		printf("WorkMode: -- One Time FIFO -- \n");
		printf("\n");
	
		int tmp=g_ExamParam.SamplesPerChannel/4;
		if(tmp==0)tmp=1;
		g_ExamParam.SamplesPerChannel=tmp*4;
		g_OutBufSize=g_ExamParam.SamplesPerChannel*4;	
	
		int *pSig = new int[g_OutBufSize];
		printf("SamplesPerChannel = %d   ",g_ExamParam.SamplesPerChannel);
		printf("OutFreq = %d Hz\n",g_ExamParam.OutFreq);
		CalcSignal(pSig, g_ExamParam.SamplesPerChannel);
		if(g_ExamParam.CycleOneTime==0)	//  
		{
			FifoOutputCPU(pSig, g_OutBufSize);
		}
		if(g_ExamParam.CycleOneTime==1)	//  
		{
			printf("Press any key for stop!\n");
			while(!_kbhit())
			{
				if(FifoOutputCPU(pSig, g_OutBufSize)==0)break;
				nblock++;
    			printf("\rBlock %d",nblock);
			}
			_getch(); 
		}
			printf("\n");
			delete pSig;
			return 1;
	}

//-------------------------------------------------------------------------

	if(g_ExamParam.WorkMode==2)	//   (Cycle DMA) 
	{
		printf("WorkMode: -- Cycle DMA -- \n");
		printf("\n");
		int tmp=g_ExamParam.SamplesPerChannel/1024;
		if(tmp==0)tmp=1;
		g_ExamParam.SamplesPerChannel=tmp*1024;
		g_OutBufSize=g_ExamParam.SamplesPerChannel*4;	
		CorrectOutFreq();
		printf("SamplesPerChannel = %d   ",g_ExamParam.SamplesPerChannel);
		printf("OutFreq = %d Hz\n",g_ExamParam.OutFreq);
		BRDctrl_StreamCBufAlloc buf_dscr;
		buf_dscr.dir = BRDstrm_DIR_OUT;
		buf_dscr.isCont = g_ExamParam.IsSystemMemory; 
		buf_dscr.blkNum = 1;
		buf_dscr.blkSize = g_OutBufSize;
		buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr);
		CalcSignal((S32*)buf_dscr.ppBlk[0], g_ExamParam.SamplesPerChannel);
		
		FifoOutputCycleDMA();

	    printf("Press any key for stop!\n");
		Enable=0;
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE,  &Enable); //  	
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
		delete[] buf_dscr.ppBlk;
		printf("\n");
		return 1;

	}
//------------------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==3)	//  FIFO (Cycle FIFO) 
	{
		printf("WorkMode: -- Cycle FIFO -- \n");
		printf("\n");
	
		int tmp=g_ExamParam.SamplesPerChannel/4;
		if(tmp==0)tmp=1;
		g_ExamParam.SamplesPerChannel=tmp*4;
		g_OutBufSize=g_ExamParam.SamplesPerChannel*4;	
	
		int *pSig = new int[g_OutBufSize];
		CorrectOutFreq();
		printf("SamplesPerChannel = %d   ",g_ExamParam.SamplesPerChannel);
		printf("OutFreq = %d Hz\n",g_ExamParam.OutFreq);
		CalcSignal(pSig, g_ExamParam.SamplesPerChannel);
		FifoOutputCPUCycleFIFO(pSig, g_OutBufSize,g_ExamParam.SamplesPerChannel);
		printf("Press any key for stop!\n");
		while(!_kbhit());
		Enable = 0;
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE, &Enable); //   
		printf("\n");
		delete pSig;
		_getch();
		return 1;

	}
return 1; //!!!
}
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
//*********************************************************************************************
//		         
//*********************************************************************************************
S32 CalcSignal(S32 *samples, S32 nsamples)
{
	S32 hi,low,nstbdac,lstbdac;
	double delta=PI2*(double)g_ExamParam.OutFreq/(double)g_ExamParam.ClockValue;
	if(g_ExamParam.TypeOfSignal==0)
	{
		for(int i=0;i<nsamples;i++)
		{
			low=(S32)(g_ExamParam.AmpChan0*sin(i*delta));
			hi=(S32)(g_ExamParam.AmpChan1*sin(i*delta));
			samples[i]=(0xffff & low) | (0xffff0000 & hi<<16);
		}
	}
	if(g_ExamParam.TypeOfSignal==1)
	{
		for(int i=0;i<nsamples;i++)
		{
			low=(S32)(g_ExamParam.AmpChan0*sin(i*delta));
			hi=(S32)(g_ExamParam.AmpChan0*cos(i*delta));
		}
	}
//-----------------------------------------------------------------------
	if(g_ExamParam.Zeroing==1)
	{
 		lstbdac=g_EnableCodogram.estrdac-g_EnableCodogram.sstrdac;
		nstbdac=nsamples/lstbdac;
		for(int i=lstbdac;i<=nsamples;i +=lstbdac)
		{
			samples[i-1]=0;
			samples[i-2]=0;
		}
	}
 
return 1;

}
//*********************************************************************************************

//*********************************************************************************************
//         
//*********************************************************************************************
void CorrectOutFreq(void)
{
	double npi;
	double nnp;
	double delta=PI2*(double)g_ExamParam.OutFreq/(double)g_ExamParam.ClockValue;
	npi=(delta*(double)g_ExamParam.SamplesPerChannel)/PI2;
	nnp =floor(npi+0.5);
	delta=PI2*(double)nnp/(double)g_ExamParam.SamplesPerChannel;
	double freq=floor(delta*(double)g_ExamParam.ClockValue/PI2+0.5);
	g_ExamParam.OutFreq=freq;
 }
//*********************************************************************************************
//          FIFO
//*********************************************************************************************
S32 FifoOutputCPU(PVOID pSig, ULONG bBufSize)
{

	S32		status;
	ULONG Status = 0;
	ULONG Enable = 0;
	U32		statusFIFO=0x4;
	S32	ncycle=0;
	S32 timeout;
	BRD_DataBuf data_buf;
	data_buf.pData = pSig;
	data_buf.size = bBufSize;
	Enable = 0;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE, &Enable); //   
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFORESET, NULL); //  FIFO 
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_PUTDATA, &data_buf);

	BRD_DacSpec dacSpec;
	dacSpec.command=DAC214X125Mcmd_SETCYCLEMODE;
	dacSpec.arg= (PVOID)&ncycle; 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
	if(BRD_errcmp(status, BRDerr_OK))
	{
	//	printf("DAC214X125Mcmd_SETCYCLEMODE: ncycle= %d \n",ncycle);
	}
	else
		DisplayError(status, "DAC214X125Mcmd_SETCYCLEMODE");


	Enable = 1;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE, &Enable); //   
	statusFIFO=0x1000;
	timeout=10000;
    while((statusFIFO & 0x1000)!=0)//      FIFO  
	{
		 status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFOSTATUS, &statusFIFO); 
		 timeout--;
		 if(timeout<0)
		 {
			Enable = 0;
			status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE, &Enable); //   
			printf("\nTIME-OUT! \n");
			return 0;
		 }
	}
	Enable = 0;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE, &Enable); //   
	return 1;
}
//*****************************************************************************************************
//     FIFO        FIFO  
//*****************************************************************************************************
S32 FifoOutputCPUCycleFIFO(PVOID pSig, U32 bBufSize, U32 ncycle)
{

	S32		status;
	U32 Status = 0;
	U32 Enable = 0;
	BRD_DataBuf data_buf; 
	data_buf.pData = pSig;
	data_buf.size = bBufSize;
	ULONG  cycle=1; 

	Enable = 0;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE, &Enable); //   
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFORESET, NULL); //  FIFO 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_PUTDATA, &data_buf);
//	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_PUTDATA, &data_buf);
//	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_PUTDATA, &data_buf);

	BRD_DacSpec dacSpec;
	dacSpec.command=DAC214X125Mcmd_SETCYCLEMODE;

	dacSpec.arg= (PVOID)&ncycle; 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_SETSPECIFIC,  &dacSpec); 
	if(BRD_errcmp(status, BRDerr_OK))
	{
		//printf("DAC214X125Mcmd_SETCYCLEMODE: ncycle= %d \n",ncycle);
	}
	else
		DisplayError(status, "DAC214X125Mcmd_SETCYCLEMODE");


		Enable = 1;
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE, &Enable); //   
	
	return 1;
}
//****************************************************************************************

//****************************************************************************************
//****************************************************************************************

//****************************************************************************************
//         FIFO - 
//****************************************************************************************
S32 FifoOutputDMA(void)
{
	S32		status;
	ULONG Status = 0;
	ULONG Enable = 0;
	int fl_break = 0;
	U32		statusFIFO=0x1000;
	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle=0;
	ULONG flag = BRDstrm_DRQ_HALF; 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_SETDRQ, &flag);
	Enable=0;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE,  &Enable); //  
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFORESET, NULL); //  FIFO 
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_RESETFIFO, NULL);
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	Enable=1;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE,  &Enable); //  

	ULONG msTimeout = 10000; //       1 .
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
	if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	//   -
			printf("\nTIME-OUT! \n");
			status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_STOP, NULL); //  
			return 0;
	}



	statusFIFO=0x1000;
	while((statusFIFO & 0x1000)!=0)//      FIFO 
	{
		   status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFOSTATUS, &statusFIFO); 
	}

	Enable = 0;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE,  &Enable); //  
	return 1;

}
//***************************************************************************************************

//*********************************************************************************************
//*********************************************************************************************
//  ()       FIFO  - 
//*********************************************************************************************
S32 FifoOutputCycleDMA(void)
{

	S32		status;
	ULONG Status = 0;
	ULONG Enable = 0;
	U32 statusFIFO;
	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 1; //  
	ULONG msTimeout = 20000; 
	int	nblock=0; 
	ULONG flag = BRDstrm_DRQ_HALF; 

	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_SETDRQ, &flag);
	Enable=0;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE,  &Enable); //  
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFORESET, NULL); //  FIFO 
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_RESETFIFO, NULL);
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  

	Enable=1;
	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_ENABLE,  &Enable); //  
	
	msTimeout = 2000; //       20 .
	while(!_kbhit())
	{
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
		if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
		{	//   -
			printf("\nTIME-OUT! \n");
			status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFOSTATUS, &statusFIFO); 

			return 1;
		}
 	//	status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_DAC_FIFOSTATUS, &statusFIFO); 
		//if((statusFIFO>>8)&1)
		//{
		//	printf("\nUnderflow! \n");
		//	printf("Press any key for stop!\n");

		//	_getch();
		//	return 0;

		//}
		nblock++;
		printf("\rBlock %d",nblock);
	}
	_getch();
	Enable=0;

	return 0;

}
//*********************************************************************************************
//=*********************************************************************************
//						  
//=*********************************************************************************
bool    ReadIniFile( TCHAR *pFileName )
{
	TCHAR Buffer[128];
	TCHAR *endptr;
	TCHAR iniFilePath[MAX_PATH];
	FILE    *stream;

	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);

	_tcscat_s(iniFilePath, pFileName);
	stream = fopen(iniFilePath, "rt" );
    if( stream == NULL)return false;
	else     fclose(stream);

    for(int i=0; i<sizeof(iniEntry)/sizeof(iniEntry[0]); i++ )
	{
		GetPrivateProfileString(iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer), iniFilePath);
		switch(iniEntry[i].format){
			case 0:	
				{
					int     base = 10;
					char    *s = Buffer;
					while (isspace(*s)) s++;
                    if( (s[0]=='0') && ((s[1]=='x') || (s[1]=='X')) )
                    base = 16;
                    *(int*)iniEntry[i].ptr = strtoul( Buffer, &endptr, base );
				}
				break;
			case 1:	*(float*)iniEntry[i].ptr=atof(Buffer);
				break;
			case 2:	*(double*)iniEntry[i].ptr=atof(Buffer);
				break;
			case 3:	 lstrcpy((TCHAR*)iniEntry[i].ptr,Buffer);
				break;

		}
	}
	return true;
}

//
// End of file
//
